﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Add_AddUnique_Method
{
    public partial class Form1 : Form
    {
        UniqueStocksList<Stocks> UList; // Fonctionne  avec déclaration class UniqueList<T> : List<T> where T:Stocks
        //UniqueStocksList UList;          // Fonctionne  avec déclaration class UniqueList : List<Stocks>

        public Form1()
        {
            InitializeComponent();

            // J'ai besoin de sauver ma collection dans un fichier Stocks.bin
            //StockDeSerialise(Environment.CurrentDirectory + "\\Stocks.bin", ref UList);

            // Fonctionne  avec déclaration class UniqueList : List<Stocks>
            // mais il faut déclarer la méthode public bool AddUnique(Stocks item)
            //UList = new UniqueStocksList(UniqueStocksList.UniqueKey.Symbol);              // Commenter si vous déserialiser la collection

            // Fonctionne  avec déclaration class UniqueList<T> : List<T> where T:Stocks
            // mais il faut déclarer la méthode public bool AddUnique(T item)
            UList = new UniqueStocksList<Stocks>(UniqueStocksList<Stocks>.UniqueKey.Name);  // Commenter si vous déserialiser la collection

            richTextBox1.AppendText(string.Format(" AAPL Add = {0}\r\n", UList.AddUnique(new Stocks { Symbol = "AAPL", Name = "Apple Inc." })));
            richTextBox1.AppendText(string.Format(" MSFT Add = {0}\r\n", UList.AddUnique(new Stocks { Symbol = "MSFT", Name = "Microsoft" })));
            richTextBox1.AppendText(string.Format(" AAPL Add = {0}\r\n", UList.AddUnique(new Stocks { Symbol = "AAPL", Name = "Apple Inc." })));
            richTextBox1.AppendText(string.Format(" NFLX Add = {0}\r\n", UList.AddUnique(new Stocks { Symbol = "NFLX", Name = "Netflix." })));
            richTextBox1.AppendText(string.Format(" GOOG Add = {0}\r\n", UList.AddUnique(new Stocks { Symbol = "GOOG", Name = "Google" })));
            richTextBox1.AppendText(string.Format(" MSFT Add = {0}\r\n", UList.AddUnique(new Stocks { Symbol = "MSFT", Name = "Microsoft" })));
            richTextBox1.AppendText(string.Format(" TSLA Add = {0}\r\n", UList.AddUnique(new Stocks { Symbol = "TSLA", Name = "Tesla" })));

            richTextBox1.AppendText("\r\n");
            foreach (var item in UList)
            {
                richTextBox1.AppendText(string.Format("Symbol: {0}  Name: {1}\r\n", item.Symbol, item.Name));
            }

            richTextBox1.AppendText("\r\nSort Symbol Default Ascending\r\n");
            foreach (var item in UList)
            {
                richTextBox1.AppendText(string.Format("Symbol: {0}  Name: {1}\r\n", item.Symbol, item.Name));
            }

            UList.Sort();
            richTextBox1.AppendText("\r\nSort Symbol Default Ascending\r\n");
            foreach (var item in UList)
            {
                richTextBox1.AppendText(string.Format("Symbol: {0}  Name: {1}\r\n", item.Symbol, item.Name));
            }

            UList.Sort(new Stocks.DescendingComparer());
            richTextBox1.AppendText("\r\nSort Symbol Descending\r\n");
            foreach (var item in UList)
            {
                richTextBox1.AppendText(string.Format("Symbol: {0}  Name: {1}\r\n", item.Symbol, item.Name));
            }

            UList.Remove(new Stocks() { Symbol = "AAPL", Name = "" });
            richTextBox1.AppendText("\r\nRemove AAPL \r\n");
            foreach (var item in UList)
            {
                richTextBox1.AppendText(string.Format("Symbol: {0}  Name: {1}\r\n", item.Symbol, item.Name));
            }
        }

        // -------------------------------------------------------------------------------------------------------
        void StockSerialise(string FL, ref UniqueStocksList<Stocks> UL)
        {
            if (UL != null)
            {
                IFormatter formatter = new BinaryFormatter();
                Stream stream = new FileStream(FL, FileMode.Create, FileAccess.Write, FileShare.None);
                formatter.Serialize(stream, UL);
                stream.Close();
            }
        }

        // -------------------------------------------------------------------------------------------------------
        void StockDeSerialise(string FileName, ref UniqueStocksList<Stocks> UP)
        //void StockDeSerialise(string FileName, ref UniqueStocksList UP)
        {
            if (File.Exists(FileName))
            {
                try
                {
                    IFormatter formatter = new BinaryFormatter();
                    Stream stream = new FileStream(FileName, FileMode.Open, FileAccess.Read, FileShare.Read);
                    UP = (UniqueStocksList<Stocks>)formatter.Deserialize(stream);  
                    stream.Close();
                }
                catch (Exception ex)
                {
                    UP = new UniqueStocksList<Stocks>(UniqueStocksList<Stocks>.UniqueKey.Name);
                    //throw;
                }
            }
            else
            {
                UP = new UniqueStocksList<Stocks>(UniqueStocksList<Stocks>.UniqueKey.Name);
            }
        }

        // -------------------------------------------------------------------------------------------------------
        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            StockSerialise(Environment.CurrentDirectory + "\\Stocks.bin", ref UList);
        }
    }
}