﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Add_AddUnique_Method
{
    [Serializable]
    public class Stocks : IComparable
    {
        public string Symbol { get; set; }
        public string Name { get; set; }

        public int CompareTo(object obj)
        {
            Stocks orderToCompare = obj as Stocks;
            if (String.Compare(orderToCompare.Symbol, Symbol) < 0)
            {
                return 1;
            }

            if (String.Compare(orderToCompare.Symbol, Symbol) > 0)
            {
                return -1;
            }

            // The orders are equivalent.
            return 0;
        }

        [Serializable]
        public class StocksSymbolComparer : IEqualityComparer<Stocks>
        {
            public bool Equals(Stocks x, Stocks y)
            {
                return x.Symbol.Equals(y.Symbol, StringComparison.InvariantCultureIgnoreCase);
            }

            public int GetHashCode(Stocks obj)
            {
                return obj.Name.GetHashCode();
            }
        }

        [Serializable]
        public class DescendingComparer : IComparer<Stocks>
        {
            public int Compare(Stocks x, Stocks y)
            {
                return y.CompareTo(x);
            }
        }

        public override bool Equals(object obj)
        {
            if (obj == null) return false;
            Stocks objAsPart = obj as Stocks;
            if (objAsPart == null) return false;
            else return Equals(objAsPart);
        }

        public bool Equals(Stocks other)
        {
            if (other == null) return false;
            return (this.Symbol.Equals(other.Symbol));
        }
    }
}
